/*
 *   Copyright (c) 2003 by GrAnd (rtads@mail.ru)
 *
 *     .
 *       .     
 *    ,        
 *  .        ,
 *          " ".  
 *
 *           ( ).
 *        Build  ,  
 *   Settings...,     Add file    
 *  . 
 *
 */

#define USE_HTML_STATUS
#define USE_HTML_PROMPT
#define GENERATOR_INCLUDED


#include <advr.t>
#include <gameinfo.t>
#include <stdr.t>
#include <generator.t>
#include <errorru.t>
#include <extendr.t>


getGameInfo: function
{
    return ['Name', '  ,   .',
            'Byline', '',
            'Desc', '      ,   .',
            'Version', '1.0',
            'ReleaseDate', getGameInfoToday(),
            'Language', 'RU'];
}

/*
 *     :     wolkikoza.jpg
 *       html 
 */
modify version
 sdesc = {
     "\b<table cellspacing=5 CELLPADDING=15><tr><td>
       <IMG SRC='wolkikoza.jpg'>
      </td><td>
      <b>  ,   .</b>
      \n    . \n
       . \n 
      1.0
     </td></tr></table>\b";
}
;

replace introduction: function
{
"\b    . !\b";
}

leadVerb:deepverb
	vopr=" "
	sdesc=""
	verb='' ''
	doAction = 'Lead'
;

modify thing
	verDoLead(actor)="<<ZAG(self,&vdesc)>>  ."
;

modify HelpVerb
action(actor) =
{
    "   ?\n
         ,    .\n
   ,     ,    ,  ,  .\n 
      (  ),   , .\n
        ,   , ,
  .
 ,  ,  .   .
:\n
\n
\n
  \n
    \n
 \n
 ..\n
<b>     \"\". , \" \".</b>\b
  :\n
, ()\n
 -    \n
 - \n
 -     .  -   .\n
 -     \n
 -    \n
 -   \n
 -   \n
 () -     .\n
         .\n
LINKS -   ( -   )\n \b
     
<<displayLink( 'http://www.rtads.h-type.com', 'http://www.rtads.h-type.com' )>>.\n\b
  !\n \b";
}
;

modify gothroughVerb 
	verb = ' ' ' ' ' ' ' '
;

modify Me
	lico=3
	desc ='/'
	adjective = '/' '/'
	noun = '/'
;

startroom: room     	  
	sdesc = " " 
	ldesc = "         
	  ,          
	  ,    .    
	    ,    
	  - ."	
	east=
	{
	  local lose;

	  if (koza.isLead) { koza.moveInto(rbereg); koza.isLead:=nil; }
	  if (volk.isLead)  { volk.moveInto(rbereg);  volk.isLead:=nil;  }

	  if (volk.location=rbereg && koza.location=rbereg && kapusta.location=rbereg)
	  {
	   "\n   ,     .     ,
	      ,       . ";
	   //           die()
	   win();
	  }

	  if (koza.location=startroom && kapusta.location=startroom) 
	  { 
	     "\n\t            .";
	     lose:=true;
	  }

	  if (koza.location=startroom && volk.location=startroom) 
	  { 
	    "\n,     ,
	          .";
	    lose:=true;
	  }

	  if (lose) 
	  { "\n     ,        . 
	         . "; 
	    die();
	  }
	  
	  return rbereg;
	}	
	noexit = { "       . "; return nil; }
;

rbereg: room     	  
	sdesc = " "
	ldesc = "         ,
	    .        . "
	west=
	{
		local fault;

		if (koza.isLead) { koza.moveInto(startroom); koza.isLead:=nil; }
		if (volk.isLead)  { volk.moveInto(startroom);  volk.isLead:=nil;  }

		if (koza.location=rbereg && kapusta.location=rbereg) 
		{"\n\t       
		     .";fault:=true;}

		if (koza.location=rbereg && volk.location=rbereg) 
		{"\n,     ,
		      .";fault:=true;}

		if (fault) {"\n     ,      
		 .      . "; die();}

		return startroom;
	}	 
	noexit = { "       . "; return nil; } 		
;

koza: Actor
	location=startroom
	desc='/'
	noun = '/'
	ldesc="     .      
	 , ,    , ."
	actorDesc=
	{
	if (koza.location=kapusta.location) "    ,    .";
	else if (koza.location=volk.location) "  ,     .";
	else "     .";
	}
	isHer = true
	/* ,    ,   */
	isLead=nil
	/*    ,          */
	verDoLead(actor)=
	{
	if (kapusta.location=Me) "   .";
	else if (koza.isLead) "         .";
	}
	doLead(actor)= 
	{
	volk.isLead:=nil;koza.isLead:=true;"     .";
	}
	/*     */
	actorAction(verb, dobj, prep, iobj) =
	{
	"  ,    . "; exit;
	} 
	/*       */
	disavow = "    ."
	doSynonym('Lead')='Take'
;

volk: Actor
  location=startroom
  desc = '/'
  noun = '/'
  ldesc="      ,        .
      ,    ,       ."
  actorDesc=
  {
    if (koza.location=volk.location) "        ,
        .";
    else "    ,   .";
  }
  isHim = true
  isLead=nil
  verDoLead(actor)=
  {
    if (kapusta.location=Me) "   .";
    else if (volk.isLead) "         .";
  }
  doLead(actor)= 
  {
    volk.isLead:=true;koza.isLead:=nil;
    "    ,     .";
  }
  actorAction(verb, dobj, prep, iobj) =
  {
    "  ,    . "; exit;
  } 
  disavow = "    ."
  doSynonym('Lead')='Take'
;

kapusta: item
	location=startroom
	desc ='/'
	noun = '/'
	adjective=  '/' '' '#r'
	ldesc="  ."
	isHer = true
	verDoEat(actor)="      ."
	/*      - . */
	verDoGiveTo(actor, io) =
	{
	 if (not actor.isCarrying(self))
	 {
	  "<<ZA(dToS(parserGetMe(),&sdesc))>>  <<glok(actor,1,2,actor.isThem)>> "; self.rdesc; ". ";
	 }
	 else "    . ";
	}
	doTake(actor) =
	{
	 volk.isLead:=nil; koza.isLead:=nil; 
	 pass doTake;
	}
;

ryeka: fixeditem,floatingItem
	location=Me.location
	desc ='/'
	noun = '/'
	ldesc=",       
	   ,      ."
	isHer = true
;


mostik: fixeditem,floatingItem
	location=Me.location
	desc ='/'
	noun = '/'
	ldesc="     ,     
	  .     ,  
	 . "
	isHim = true
	verDoGothrough(actor)={}
	doGothrough(actor)=
	{
	 if (Me.location=startroom) Me.travelTo(startroom.east); 
	 else Me.travelTo(rbereg.west);
	}
;

win: function
{
    "\b  , !!!\b";
    "\b:   ,  , .\n";
    while (true)
    {
        local resp;
        "\n  , , >";
        resp := upper(input());
        if ((resp = '') or (resp='restore') or (resp=''))
        {
            resp := askfile('  :',
                            ASKFILE_PROMPT_OPEN, FILE_TYPE_SAVE);
            if (resp = nil)          "  . ";
            else if (restore(resp))  "  . ";
            else
            {    parserGetMe().location.lookAround(true);
                scoreStatus(global.score, global.turnsofar);  abort;      }
        }
        else if ((resp = '') or (resp=''))
        {
            scoreStatus(0, 0);
            restart();
        }
        else if ((resp = '') or (resp=''))
        {   terminate();       quit();        abort;}
     } 
}

